import greenfoot.*;  // （World、Actor、GreenfootImage、GreenfootSound、Greenfoot及MouseInfo）
import java.awt.Color;

/**
 * 星光閃閃。
 * 
 * @author 依瑪貓
 * @version 2012/12/3
 */
public class Spark extends Actor {
    
    /** 目前星光的閃爍方向， 1 放大， -1 縮小， 0 不動。 */
    private int step = 0;
    
    /** 目前星光閃閃到第幾步驟。 */
    private int currentSteps = 0;
    
    /** 星光閃閃的顏色。 */
    private Color color = null;
    
    /**
     * 建立新的星光閃閃。
     * 
     * @param sparkColor 星光閃閃的顏色
     * @param width        雷射的寬度
     * @param height       雷射的長度
     */
    public Spark(Color sparkColor, int width, int height) {
        color = sparkColor;
        GreenfootImage image = new GreenfootImage(width, height);
        image.clear();
        setImage(image);
        createImage();
    }
    
    /**
     * 每回合執行的動作。
     * 
     */
    public void act() {
        // 放大，變亮。
        if (step > 0) {
            currentSteps++;
            if (currentSteps >= 10) {
                currentSteps = 10;
                step = -step;
            }
            createImage();
        // 縮小，變暗。
        } else if (step < 0) {
            currentSteps--;
            if (currentSteps <= 0) {
                currentSteps = 0;
                step = 0;
            }
            createImage();
        }
    }
    
    /**
     * 閃爍。
     * 
     */
    public void sparkle() {
        step = 1;
    }
    
    /**
     * 設定星光閃閃的圖。
     * 
     */
    private void createImage() {
        GreenfootImage image = getImage();
        int alpha = (currentSteps * 255) / 10;
        Color currentColor = new Color(color.getRed(), color.getBlue(), color.getGreen(), alpha);
        
        image.clear();
        image.setColor(currentColor);
        image.fill();
        
        setImage(image);
        return;
    }
}